org.apache.bcel.classfile

## Class ConstantCP

- java.lang.Object
- - org.apache.bcel.classfile.Constant
  - - org.apache.bcel.classfile.ConstantCP

- All Implemented Interfaces:
    Cloneable, Node
  Direct Known Subclasses:
    ConstantFieldref, ConstantInterfaceMethodref, ConstantInvokeDynamic, ConstantMethodref

      public abstract class ConstantCP
      extends Constant

  Abstract super class for Fieldref, Methodref, InterfaceMethodref and InvokeDynamic constants.
  Version:
    $Id: ConstantCP.java 1806200 2017-08-25 16:33:06Z ggregory $
  See Also:
    `ConstantFieldref`, `ConstantMethodref`, `ConstantInterfaceMethodref`, `ConstantInvokeDynamic`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `class_index` Deprecated. (since 6.0) will be made private; do not access directly, use getter/setter
    `protected int` | `name_and_type_index` Deprecated. (since 6.0) will be made private; do not access directly, use getter/setter

    - ### Fields inherited from class org.apache.bcel.classfile.Constant

      `tag`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ConstantCP(byte tag, int class_index, int name_and_type_index)`
    `` | `ConstantCP(ConstantCP c)` Initialize from another object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `dump(DataOutputStream file)` Dump constant field reference to file stream in binary format.
    `String` | `getClass(ConstantPool cp)`
    `int` | `getClassIndex()`
    `int` | `getNameAndTypeIndex()`
    `void` | `setClassIndex(int class_index)`
    `void` | `setNameAndTypeIndex(int name_and_type_index)`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.bcel.classfile.Constant

      `accept, clone, copy, equals, getComparator, getTag, hashCode, readConstant, setComparator`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### class_index

          @Deprecated
          protected int class_index

      Deprecated. (since 6.0) will be made private; do not access directly, use getter/setter

    - #### name_and_type_index

          @Deprecated
          protected int name_and_type_index

      Deprecated. (since 6.0) will be made private; do not access directly, use getter/setter

  - ### Constructor Detail

    - #### ConstantCP

          public ConstantCP(ConstantCP c)

      Initialize from another object.

    - #### ConstantCP

          protected ConstantCP(byte tag,
                               int class_index,
                               int name_and_type_index)

      Parameters:
        `class_index` - Reference to the class containing the field
        `name_and_type_index` - and the field signature

  - ### Method Detail

    - #### dump

          public final void dump(DataOutputStream file)
                          throws IOException

      Dump constant field reference to file stream in binary format.
      Specified by:
        `dump` in class `Constant`
      Parameters:
        `file` - Output file stream
      Throws:
        `IOException`

    - #### getClassIndex

          public final int getClassIndex()

      Returns:
        Reference (index) to class this constant refers to.

    - #### setClassIndex

          public final void setClassIndex(int class_index)

      Parameters:
        `class_index` - points to Constant_class

    - #### getNameAndTypeIndex

          public final int getNameAndTypeIndex()

      Returns:
        Reference (index) to signature of the field.

    - #### setNameAndTypeIndex

          public final void setNameAndTypeIndex(int name_and_type_index)

      Parameters:
        `name_and_type_index` - points to Constant_NameAndType

    - #### getClass

          public String getClass(ConstantPool cp)

      Returns:
        Class this field belongs to.

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Constant`
      Returns:
        String representation. not final as ConstantInvokeDynamic needs to modify

Copyright © 2004–2017 The Apache Software Foundation. All rights reserved.